// This program doesn't support Unicode.
// #define UNICODE

// for Win98 or later.
#define _WIN32_WINDOWS 0x0410

#include <windows.h>
#include <commctrl.h>
#include "runtime.h"
#include "..\res\resource.h"
#include "bit.h"
#include "main.h"
#include "smaf.h"
#include "detail.h"
#include "emusmw5.h"
#include "version.h"
#include "proll.h"

MAINOPTION MainOption;

UINT PlayingPos = 0;

//?
static HWND hMainWnd;
static HWND hDetailWnd;
static HWND hToolWnd;
static HWND hPRollWnd;

//static VOICE voices[256];
static VOICE* voices = NULL;
static UINT voicesmax = 0;

BOOL CALLBACK AboutDlgWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	if(msg == WM_INITDIALOG)
	{
		VERSION v;
		TCHAR ts[64];

		getVersion(&v);

		wsprintf(ts, "Version %d.%d.%d.%d", v.major, v.minor, v.patch, v.build);
		SetDlgItemText(hWnd, IDC_VERSION, ts);

		return TRUE;
	}
	if(msg == WM_COMMAND && (wParam == IDOK || wParam == IDCANCEL))
		EndDialog(hWnd, wParam);

	return FALSE;
}

void getTrackMenuItem(int id, LPTSTR str, COLORREF* fg, COLORREF* bg)
{
	COLORREF dummy;

	if(!fg)
		fg = &dummy;
	if(!bg)
		bg = &dummy;

	// TODO: fg color to calc from bg
	switch(id)
	{
	case ID_VTRACK1:	*fg = RGB(  0,   0,   0);	*bg = MainOption.TrackColors[0];	lstrcpy(str, "1:Track1(Silver)");		break;
	case ID_VTRACK2:	*fg = RGB(  0,   0,   0);	*bg = MainOption.TrackColors[1];	lstrcpy(str, "2:Track2(Red)");			break;
	case ID_VTRACK3:	*fg = RGB(  0,   0,   0);	*bg = MainOption.TrackColors[2];	lstrcpy(str, "3:Track3(Green)");		break;
	case ID_VTRACK4:	*fg = RGB(  0,   0,   0);	*bg = MainOption.TrackColors[3];	lstrcpy(str, "4:Track4(Blue)");			break;
	case ID_VTRACK5:	*fg = RGB(  0,   0,   0);	*bg = MainOption.TrackColors[4];	lstrcpy(str, "5:Track5(Yellow)");		break;
	case ID_VTRACK6:	*fg = RGB(  0,   0,   0);	*bg = MainOption.TrackColors[5];	lstrcpy(str, "6:Track6(Cyan)");			break;
	case ID_VTRACK7:	*fg = RGB(  0,   0,   0);	*bg = MainOption.TrackColors[6];	lstrcpy(str, "7:Track7(Purple)");		break;
	case ID_VTRACK8:	*fg = RGB(  0,   0,   0);	*bg = MainOption.TrackColors[7];	lstrcpy(str, "8:Track8(White)");		break;
	case ID_VTRACK9:	*fg = RGB(255, 255, 255);	*bg = MainOption.TrackColors[8];	lstrcpy(str, "Q:Track9(Black)");		break;
	case ID_VTRACK10:	*fg = RGB(255, 255, 255);	*bg = MainOption.TrackColors[9];	lstrcpy(str, "W:Track10(DarkRed)");		break;
	case ID_VTRACK11:	*fg = RGB(255, 255, 255);	*bg = MainOption.TrackColors[10];	lstrcpy(str, "E:Track11(DarkGreen)");	break;
	case ID_VTRACK12:	*fg = RGB(255, 255, 255);	*bg = MainOption.TrackColors[11];	lstrcpy(str, "R:Track12(DarkBlue)");	break;
	case ID_VTRACK13:	*fg = RGB(255, 255, 255);	*bg = MainOption.TrackColors[12];	lstrcpy(str, "T:Track13(DarkYellow)");	break;
	case ID_VTRACK14:	*fg = RGB(255, 255, 255);	*bg = MainOption.TrackColors[13];	lstrcpy(str, "Y:Track14(DarkCyan)");	break;
	case ID_VTRACK15:	*fg = RGB(255, 255, 255);	*bg = MainOption.TrackColors[14];	lstrcpy(str, "U:Track15(DarkPurple)");	break;
	case ID_VTRACK16:	*fg = RGB(255, 255, 255);	*bg = MainOption.TrackColors[15];	lstrcpy(str, "I:Track16(Gray)");		break;
	}

	return;
}

void seek(SMAF* smaf, UINT ppos, BOOL emuseek, BOOL forcemove)
{
	PlayingPos = ppos;
	SendMessage(hPRollWnd, WM_PROLL, PROLLWM_SETCURRENTPOS, PlayingPos);

	if(emuseek)
	{
		if(!EmuSeek(PlayingPos - (smaf->start->time - smaf->start->duration)))
		{
			MessageBox(hMainWnd, "Seek failed", "Error", MB_ICONERROR | MB_OK);
		}
	}

	if(forcemove)
	{
		if(MainOption.FollowPlay)
			SendMessage(hPRollWnd, WM_PROLL, MAKEWPARAM(PROLLWM_SCROLLTO, MainOption.FollowSpace), PlayingPos);
			//SetScrollPos(hMainWnd, SB_HORZ, (int)(PlayingPos) / (int)RollWidth + FollowSpace, TRUE);
	}else
	{
		if(MainOption.FollowPlay == 1 || ((MainOption.FollowPlay == 2 || MainOption.FollowPlay == 3) && GetAsyncKeyState(VK_SHIFT) & 0x8000))
			SendMessage(hPRollWnd, WM_PROLL, MAKEWPARAM(PROLLWM_SCROLLTO, MainOption.FollowSpace), PlayingPos);
			//SetScrollPos(hMainWnd, SB_HORZ, (int)(PlayingPos) / (int)RollWidth + FollowSpace, TRUE);
	}

	InvalidateRect(hMainWnd, NULL, FALSE);
	InvalidateRect(hDetailWnd, NULL, FALSE);

	return;
}

// check this function
void setExclusiveFMCh(BYTE* data, CHPARAM* chp)
{
	data[0] = 0xF0;
	data[1] = 0x43;
	data[2] = 0x79;
	data[3] = 0x07;
	data[4] = 0x7F;
	data[5] = 0x01;
	data[6] = chp->bm;
	data[7] = chp->bl;
	data[8] = chp->pc;
	data[9] = chp->mapnote;
	data[12] = chp->drumnote;
	data[11] &= ~0x30;
	data[11] |= ((chp->lfo & 0x02) ? 0x10 : 0) | ((chp->pan & 0x10) ? 0x20 : 0);
	data[13] &= ~0x78;
	data[13] |= ((chp->pan & 0x0F) << 3);
	data[14] |= ((chp->lfo & 0x01) ? 0x40 : 0) | ((chp->pe) ? 0x20 : 0) | (chp->alg);

	return;
}

// CHECK THIS FUNCTION
void setExclusiveFMOp(BYTE* data, OPPARAM* opp)
{
	// X1 XX XX XX 23 45 67 89 AX BC DE FG

	data[0] &= ~0x0F;
	data[0] |= ((opp->sr & 0x08) ? 8 : 0) | ((opp->rr & 0x08) ? 4 : 0) | ((opp->ar & 0x08) ? 2 : 0) | ((opp->tl & 0x20) ? 1 : 0);

	data[4] = ((opp->sr & 0x07) << 4) | (opp->xof ? 8 : 0) | (opp->sus ? 2 : 0) | (opp->ksr ? 1 : 0);
	data[5] = ((opp->rr & 0x07) << 4) | (opp->dr);
	data[6] = ((opp->ar & 0x07) << 4) | (opp->sl);
	data[7] = ((opp->tl & 0x1F) << 2) | (opp->ksl);
	data[8] &= ~0x30;
	data[8] |= ((opp->multi & 0x08) ? 0x20 : 0) | ((opp->ws & 0x10) ? 0x10 : 0);
	data[9] = ((opp->dam) << 5) | ((opp->eam) ? 0x10 : 0) | ((opp->dvb) << 1) | ((opp->evb) ? 1 : 0);
	data[10] = ((opp->multi & 0x07) << 4) | (opp->dt);
	data[11] = ((opp->ws & 0x0F) << 3);

	return;
}

UINT setExclusiveFMAll(BYTE* data, CHPARAM* chp, OPPARAM* opps)
{
	UINT size;
	UINT i;

	for(i = 0; i < 0x30; i++)
		data[i] = 0;

	setExclusiveFMCh(data, chp);

	setExclusiveFMOp(data + 11, opps + 0);
	setExclusiveFMOp(data + 19, opps + 1);

	if(chp->alg <= 1)
	{
		size = 0x20;
	}else
	{
		setExclusiveFMOp(data + 27, opps + 2);
		setExclusiveFMOp(data + 35, opps + 3);
		size = 0x30;
	}

	data[size - 1] = 0xF7;

	return size;
}

UINT setExclusivePCMAll(BYTE* data, CHPARAM* chp, OPPARAM* opp)
{
	UINT i;

	for(i = 0; i < 0x1F; i++)
		data[i] = 0;

	data[0] = 0xF0;
	data[1] = 0x43;
	data[2] = 0x79;
	data[3] = 0x07;
	data[4] = 0x7F;
	data[5] = 0x01;
	data[6] = chp->bm;
	data[7] = chp->bl;
	data[8] = chp->pc;
	data[9] = chp->mapnote;
	data[10] = 0x01;
	data[11] |= ((chp->pan & 0x10) ? 0x10 : 0) | ((chp->fs & 0x80) ? 0x20 : 0) | ((chp->fs & 0x8000) ? 0x40 : 0);
	data[11] |= ((opp->ar & 0x08) ? 1 : 0) | ((opp->rr & 0x08) ? 2 : 0) | ((opp->sr & 0x08) ? 4 : 0) | ((chp->lfo & 0x02) ? 8 : 0);
	data[12] = (BYTE)((chp->fs & 0x7F00) >> 8);
	data[13] = (BYTE)(chp->fs & 0x7F);
	data[14] = ((chp->pan & 0x0F) << 3) | ((chp->pe) ? 1 : 0);
	data[15] = (chp->lfo & 0x01) ? 0x40 : 0;

	data[16] = ((opp->sr & 0x07) << 4) | ((opp->xof) ? 8 : 0) | ((opp->sus) ? 4 : 0);
	data[17] = ((opp->rr & 0x07) << 4) | (opp->dr);
	data[18] = ((opp->ar & 0x07) << 4) | (opp->sl);
	data[19] |= ((opp->tl & 0x20) ? 0x40 : 0);
	data[19] |= ((chp->lp & 0x80) ? 2 : 0);
	data[20] = ((opp->tl) & 0x1F) << 2;
	data[21] = ((opp->dam) << 5) | ((opp->eam) ? 0x10 : 0) | ((opp->dvb) << 1) | ((opp->evb) ? 1 : 0);
	data[24] = (BYTE)((chp->lp & 0x7F00) >> 8);
	data[25] = (BYTE)(chp->lp & 0x7F);
	data[26] = (BYTE)((chp->ep & 0x7F00) >> 8);
	data[27] = ((chp->rm) ? 0x20 : 0) | ((chp->ep & 0x80) ? 0x40 : 0);
	data[28] = (BYTE)(chp->ep & 0x7F);
	data[29] = chp->wavno;
	data[30] = 0xF7;

	return 0x1F;
}

void LoadVoices(LPCTSTR fn)
{
	BYTE* vm;

	{
		HANDLE hf;
		DWORD read;

		if((hf = CreateFile(fn, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL)) == INVALID_HANDLE_VALUE)
		{
			MessageBox(NULL, "DefMA3_16.vm3 couldn't open\nIt isn't required, but there are some affections.", "Error", MB_ICONERROR | MB_OK);
			return;
		}

		if(!(vm = halloc(GetFileSize(hf, NULL))))
		{
			CloseHandle(hf);
			MessageBox(NULL, "Couldn't allocate memory", "Error", MB_ICONERROR | MB_OK);
			return;
		}

		if(!ReadFile(hf, vm, GetFileSize(hf, NULL), &read, NULL))
			read = 0;

		if(read != GetFileSize(hf, NULL))
		{
			hfree(vm);
			CloseHandle(hf);
			MessageBox(NULL, "Couldn't read correctly", "Error", MB_ICONERROR | MB_OK);
			return;
		}

		CloseHandle(hf);
	}

	if(COMPARE4(vm, "FMM3"))
	{
		hfree(vm);
		MessageBox(NULL, "This is not FMM3", "Error", MB_ICONERROR | MB_OK);
		return;
	}

	{
		BITFILE* bf;
		int cnt, i;
		BYTE* p;
		DWORD size;

		p = vm + 8;
		size = SwapDword(vm + 4);

		for(cnt = 0; (DWORD)(p - vm - 8) < size/* && cnt < 128*/; cnt++)
		{
			BYTE rsize;

			UINT rec;

			rec = voicesmax;

			if(voicesmax < rec + 1)
			{
				voicesmax = rec + 1;
				voices = hrealloc(voices, (voicesmax) * sizeof(VOICE));
			}

			p += 2;	// skip record no
			//: VVal
			rsize = *p;						p += 1;

			voices[rec].chp.bm = *p;		p += 1;
			voices[rec].chp.bl = *p;		p += 1;
			voices[rec].chp.pc = *p;		p += 1;
			voices[rec].chp.mapnote = *p;	p += 1;

			voices[rec].chp.type = *p;		p += 1;

			memcopy(voices[rec].name, p, 16);
			voices[rec].name[16] = '\0';
			p += 16;

			// Voiceǂݍ݂PCMԂ(L֥`)
			switch(voices[rec].chp.type)
			{
			case 0:
				voices[rec].chp.drumnote = *p;	p += 1;
				rsize -= 1;

				bf = bitopen(p, 55);

				voices[rec].chp.pan = bitnread(bf, 5);
				bitnread(bf, 3);

				voices[rec].chp.lfo = bitnread(bf, 2);
				voices[rec].chp.pe = bitnread(bf, 1);
				bitnread(bf, 2);
				voices[rec].chp.alg = bitnread(bf, 3);

				for(i = 0; i < 4; i++)
				{
					voices[rec].opp[i].sr = bitnread(bf, 4);
					voices[rec].opp[i].xof = bitread(bf);
					bitread(bf);
					voices[rec].opp[i].sus = bitread(bf);
					voices[rec].opp[i].ksr = bitread(bf);

					voices[rec].opp[i].rr = bitnread(bf, 4);
					voices[rec].opp[i].dr = bitnread(bf, 4);

					voices[rec].opp[i].ar = bitnread(bf, 4);
					voices[rec].opp[i].sl = bitnread(bf, 4);

					voices[rec].opp[i].tl = bitnread(bf, 6);
					voices[rec].opp[i].ksl = bitnread(bf, 2);

					voices[rec].opp[i].dam = bitnread(bf, 3);
					voices[rec].opp[i].eam = bitread(bf);
					voices[rec].opp[i].dvb = bitnread(bf, 3);
					voices[rec].opp[i].evb = bitread(bf);

					voices[rec].opp[i].multi = bitnread(bf, 4);
					bitread(bf);
					voices[rec].opp[i].dt = bitnread(bf, 3);

					voices[rec].opp[i].ws = bitnread(bf, 5);
					voices[rec].opp[i].fb = bitnread(bf, 3);
				}

				bitclose(bf);
				break;
			case 1:
				voices[rec].chp.fs = SwapWord(p);	p += 2;
				rsize -= 2;

				bf = bitopen(p, 14);

				voices[rec].chp.pan = bitnread(bf, 5);
				bitnread(bf, 2);
				voices[rec].chp.pe = bitread(bf);

				voices[rec].chp.lfo = bitnread(bf, 2);
				bitnread(bf, 6);

				voices[rec].opp[0].sr = bitnread(bf, 4);
				voices[rec].opp[0].xof = bitread(bf);
				bitread(bf);
				voices[rec].opp[0].sus = bitread(bf);
				bitread(bf);

				voices[rec].opp[0].rr = bitnread(bf, 4);
				voices[rec].opp[0].dr = bitnread(bf, 4);

				voices[rec].opp[0].ar = bitnread(bf, 4);
				voices[rec].opp[0].sl = bitnread(bf, 4);

				voices[rec].opp[0].tl = bitnread(bf, 6);
				bitnread(bf, 2);

				bitread(bf);
				voices[rec].opp[0].dam = bitnread(bf, 2);
				voices[rec].opp[0].eam = bitread(bf);
				bitread(bf);
				voices[rec].opp[0].dvb = bitnread(bf, 2);
				voices[rec].opp[0].evb = bitread(bf);

				bitnread(bf, 16);

				voices[rec].chp.lp = bitnread(bf, 16);
				voices[rec].chp.ep = bitnread(bf, 16);

				voices[rec].chp.rm = bitread(bf);
				bitnread(bf, 4);
				voices[rec].chp.wavno = bitnread(bf, 3);

				bitclose(bf);

				break;
			}

			p += rsize - 5 - 16;
		}
	}

	hfree(vm);

	return;
}

void setVoice(UINT rec, BOOL forcelsb, UINT lsb, BOOL forcepch, UINT pch)
{
	BYTE cmd[0x30] = {0};
	UINT cmdsize;

	CHPARAM chp = voices[rec].chp;
	OPPARAM opp[4];

	opp[0] = voices[rec].opp[0];
	opp[1] = voices[rec].opp[1];
	opp[2] = voices[rec].opp[2];
	opp[3] = voices[rec].opp[3];

	//chp.bm = 124;
	//chp.bl = banklsb;
	if(forcelsb)
		chp.bl = lsb;
	if(forcepch)
		chp.pc = pch;

	if(chp.type == 0x00)
		cmdsize = setExclusiveFMAll(cmd, &chp, opp);
	else
		cmdsize = setExclusivePCMAll(cmd, &chp, opp);

	if(EmuSetMidiMsg(cmd, cmdsize))
	{
		TCHAR ts[256];

		wsprintf(ts, "PresetVoices EmuSetMidiMsg(Assign) failed at Bank%d:%d, PC%d, Note%d", chp.bm, chp.bl, chp.pc, chp.mapnote);
		MessageBox(NULL, ts, "Error", MB_ICONERROR | MB_OK);
		return;
	}

	return;
}

void PresetVoices(void)
{
	UINT i;

	// normal set
	for(i = 0; i < voicesmax; i++)
	{
		int rec = i;
		/*
		//ݒ胊Zbg?Kvۂ?
		{
			BYTE cmd[0x0B] = {0xF0, 0x43, 0x79, 0x06, 0x7F, 0x02, voices[rec].chp.bm, voices[rec].chp.bl, voices[rec].chp.pc, voices[rec].chp.mapnote, 0xF7};

			if(EmuSetMidiMsg(cmd, 0x0B))
			{
				TCHAR ts[256];

				wsprintf(ts, "PresetVoices EmuSetMidiMsg(Erase) failed at Bank%d:%d, PC%d, Note%d", voices[rec].chp.bm, voices[rec].chp.bl, voices[rec].chp.pc, voices[rec].chp.mapnote);
				MessageBox(NULL, ts, "Error", MB_ICONERROR | MB_OK);
				return;
			}
		}
		*/

		//*
		if(voices[rec].chp.bm == 124 && voices[rec].chp.bl == 0)
		{
			int j;

			for(j = 0; j < 10; j++)
				setVoice(rec, TRUE, j, FALSE, 0);
		}else
		//*/
		if(voices[rec].chp.bm == 125 && voices[rec].chp.bl == 0)
		{
			int j;

			setVoice(rec, FALSE, 0, FALSE, 0);
			for(j = 2; j < 10; j++)
				setVoice(rec, FALSE, 0, TRUE, j);
		}
		else
			setVoice(rec, FALSE, 0, FALSE, 0);
	}

	return;
}

void InitMidiMode(void)
{
	// terminate
	// after
	//Emu526829();

	// MONOPHOLIC EXCLUSIVES?
	/*
	{
		BYTE cmd[] = {0xF0, 0x43, 0x79, 0x06, 0x7F, 0x13, 0x00, 0xF7};
		if(EmuSetMidiMsg(cmd, sizeof(cmd)))
		{
			MessageBox(NULL, "InitMidiMode F0 43 79 06 7F 13 00 F7 failed", "Error", MB_ICONERROR | MB_OK);
			return;
		}
	}
	{
		BYTE cmd[] = {0xF0, 0x43, 0x79, 0x06, 0x7F, 0x11, 0x00, 0xF7};
		if(EmuSetMidiMsg(cmd, sizeof(cmd)))
		{
			MessageBox(NULL, "InitMidiMode F0 43 79 06 7F 11 00 F7 failed", "Error", MB_ICONERROR | MB_OK);
			return;
		}
	}
	//*/

	/*
	Emu5282();

	// Ȃ?
	{
		BYTE cmd[] = {0xF0, 0x43, 0x79, 0x06, 0x7F, 0x13, 0x00, 0xF7};
		if(EmuSetMidiMsg(cmd, sizeof(cmd)))
		{
			MessageBox(hWnd, "SetMidiMsgX1 failed", "Error", MB_ICONERROR | MB_OK);
			break;
		}
	}
	{
		BYTE cmd[] = {0xF0, 0x43, 0x79, 0x06, 0x7F, 0x11, 0x00, 0xF7};
		if(EmuSetMidiMsg(cmd, sizeof(cmd)))
		{
			MessageBox(hWnd, "SetMidiMsgX2 failed", "Error", MB_ICONERROR | MB_OK);
			break;
		}
	}

	// Ȃ?
	// CC BankSelect
	{
		BYTE cmd[] = {0xB0, 0x00, 0x7C};
		if(EmuSetMidiMsg(cmd, sizeof(cmd)))
		{
			MessageBox(hWnd, "SetMidiMsg5 failed", "Error", MB_ICONERROR | MB_OK);
			break;
		}
	}
	{
		BYTE cmd[] = {0xB0, 0x20, 0x00};
		if(EmuSetMidiMsg(cmd, sizeof(cmd)))
		{
			MessageBox(hWnd, "SetMidiMsg6 failed", "Error", MB_ICONERROR | MB_OK);
			break;
		}
	}
	// PC
	{
		BYTE cmd[] = {0xC0, 0};
		if(EmuSetMidiMsg(cmd, sizeof(cmd)))
		{
			MessageBox(hWnd, "SetMidiMsg7 failed", "Error", MB_ICONERROR | MB_OK);
			break;
		}
	}
	*/

	/*
	// unknown exclusive
	{
		BYTE cmd[] = {0xF0, 0x43, 0x79, 0x06, 0x7F, 0x02, 0x7C, 0x00, 0x00, 0x00, 0xF7};
		if(EmuSetMidiMsg(cmd, sizeof(cmd)))
		{
			MessageBox(hWnd, "SetMidiMsgX4 failed", "Error", MB_ICONERROR | MB_OK);
			break;
		}
	}
	*/

	// Reset
	{
		BYTE cmd[] = {0xF0, 0x43, 0x79, 0x06, 0x7F, 0x7F, 0xF7};
		if(EmuSetMidiMsg(cmd, sizeof(cmd)))
		{
			MessageBox(NULL, "SetMidiMsg ini failed", "Error", MB_ICONERROR | MB_OK);
			return;
		}
	}

	EmuMIDISetVolume();

	PresetVoices();

	return;
}

void settitle(HWND hWnd, SMAF* smaf, BOOL emusounding, BOOL midisounding)
{
	if(!smaf)
		SetWindowText(hWnd, "MMF Tool");
	else
	{
		if(emusounding)
		{
			TCHAR ts[256];
			DWORD emuinfo = EmuInfo();

			wsprintf(ts, "MMF Tool EMU:%05ums ", PlayingPos);
			if(emuinfo & 0x01)
				lstrcat(ts, "LED ");
			if(emuinfo & 0x02)
				lstrcat(ts, "Vib ");
			SetWindowText(hWnd, ts);
		}else
			if(midisounding)
			{
				TCHAR ts[256];
				//DWORD emuinfo = EmuInfo();	// EmuAMIDIłł悤ɂB

				wsprintf(ts, "MMF Tool MIDI:%05ums", PlayingPos);
				SetWindowText(hWnd, ts);
			}else
			{
				TCHAR ts[32];

				wsprintf(ts, "MMF Tool %05ums", PlayingPos);
				SetWindowText(hWnd, ts);
			}
	}

	return;
}

void OpenSMAFCommand(HWND hWnd, SMAF** smaf, LPCTSTR fname)
{
	if(*smaf)
		SendMessage(hWnd, WM_COMMAND, ID_CLOSE, 0);

	PlayingPos = 0;

	*smaf = LoadSmaf(fname);

	SetScrollPos(hWnd, SB_HORZ, 0, TRUE);
	SetScrollPos(hWnd, SB_VERT, 0, TRUE);

	SendMessage(hDetailWnd, WM_USER, 0, (LPARAM)*smaf);
	SendMessage(hPRollWnd, WM_PROLL, PROLLWM_SETSMAF, (LPARAM)*smaf);

	settitle(hWnd, *smaf, FALSE, FALSE);

	return;
}

void setvtrack(int track)
{
	SendMessage(hPRollWnd, WM_PROLL, PROLLWM_SETVISIBLETRACK, track);
	if(MainOption.PlayVisibleOnly)
		EmuMIDISetSoloCh(track);
	InvalidateRect(hPRollWnd, NULL, FALSE);

	return;
}

void formatso(BYTE inputtingtype, int inputtingnum)
{
	LPTSTR str = (LPTSTR)SendMessage(hPRollWnd, WM_PROLL, PROLLWM_GETOPTIONSTRING, 0);

	switch(inputtingtype)
	{
	case 0:
		break;
	case VK_ESCAPE:	wsprintf(str, "(Escape)");								break;
	case VK_OEM_2:	wsprintf(str, "HELP: View readme. sorry.");				break;
	case 'R':		wsprintf(str, "Refresh Rate: %d [ms]", inputtingnum);	break;
	case 'D':
		switch(inputtingnum)
		{
		case 0:
			wsprintf(str, "Draw Function: %d: No DoubleBuffer", inputtingnum);
			break;
		case 1:
			wsprintf(str, "Draw Function: %d: DoubleBuffer use CreateDIBSection(SLOW)", inputtingnum);
			break;
		case 2:
			wsprintf(str, "Draw Function: %d: DoubleBuffer use CreateCompatibleBitmap(Fast?)", inputtingnum);
			break;
		default:
			wsprintf(str, "Draw Function: %d (ILLEGAL VALUE)", inputtingnum);
			break;
		}
		break;
	case 'H':	wsprintf(str, "PianoRoll's Height: %d", inputtingnum);			break;
	case 'T':	wsprintf(str, "Tempo: %d", inputtingnum);						break;
	case 'K':	wsprintf(str, "KeyPitch: %d", inputtingnum);						break;
	case 'W':	wsprintf(str, "PianoRoll's Width divider: %d", inputtingnum);	break;
	case 'F':
		switch(inputtingnum)
		{
		case 0:
			wsprintf(str, "Follow play: %d: NoFollow", inputtingnum);
			break;
		case 1:
			wsprintf(str, "Follow play: %d: AlwaysFollow", inputtingnum);
			break;
		case 2:
			wsprintf(str, "Follow play: %d: FollowOnShift", inputtingnum);
			break;
		case 3:
			wsprintf(str, "Follow play: %d: PageFollow", inputtingnum);
			break;
		default:
			wsprintf(str, "Follow play: %d (ILLEGAL VALUE)", inputtingnum);
			break;
		}
		break;
	case 'S':	wsprintf(str, "Follow space: %d [px]", -inputtingnum);				break;
	case 'G':
		wsprintf(str, "GoTo: %d [ms]", inputtingnum);
		break;
	case 'V':	wsprintf(str, "Volume: %d", inputtingnum);						break;
	case 'M':	wsprintf(str, "MoveTo: %d", inputtingnum);						break;
	case 'O':	wsprintf(str, "PlayVisibleOnly: %d", inputtingnum);				break;
	default:	wsprintf(str, "INVALID TYPE");									break;
	}

	return;
}

LRESULT CALLBACK MainWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static BOOL emusounding = FALSE;
	static BOOL midisounding = FALSE;
	static SMAF* smaf = NULL;
	static int refrate = 10;

	static int inputtingnum;
	static char inputtingtype;
	static BOOL isinputting = FALSE;
	static BOOL isinputfirst;

	static int sndy;
	static int sndch;

	static int pch = 0;

	switch(msg)
	{
	case WM_CREATE:
		{
			TCHAR fn[MAX_PATH];

			GetModuleFileName(NULL, fn, sizeof(fn));
			lstrcpy((LPTSTR)basename(fn), "DefMA3_16.vm3");

			LoadVoices(fn);
			InitMidiMode();
		}

		{
			RECT rc;

			GetClientRect(hWnd, &rc);

			hToolWnd = CreateWindowEx(0, TOOLBARCLASSNAME, "", WS_CHILD | WS_VISIBLE | CCS_TOP | TBSTYLE_FLAT, 0, 0, 0, 0, hWnd, NULL, GetModuleHandle(NULL), NULL);
			SendMessage(hToolWnd, TB_BUTTONSTRUCTSIZE, sizeof(TBBUTTON), 0);

			SendMessage(hToolWnd, TB_SETIMAGELIST, 0, (LPARAM)ImageList_LoadImage(GetModuleHandle(NULL), MAKEINTRESOURCE(IDB_MAINTB), 16, 4, RGB(255, 0, 255), IMAGE_BITMAP, LR_DEFAULTCOLOR/*<-ꂢ?*/));

			{
				TBBUTTON tbb[] = {
					{0,		ID_NEWSMAF,		TBSTATE_ENABLED,	0,				0,	0},
					{1,		ID_OPENSMAF,	TBSTATE_ENABLED,	0,				0,	0},
					{2,		ID_COMPILESMAF,	TBSTATE_ENABLED,	0,				0,	0},
					{3,		ID_SAVESMAF,	TBSTATE_ENABLED,	0,				0,	0},
					{4,		ID_CLOSE,		TBSTATE_ENABLED,	0,				0,	0},
					{0,		0,				0,					TBSTYLE_SEP,	0,	0},
					{5,		ID_PLAY,		TBSTATE_ENABLED,	0,				0,	0},
					{6,		ID_MIDIPLAY,	TBSTATE_ENABLED,	0,				0,	0},
					{7,		ID_STOP,		TBSTATE_ENABLED,	0,				0,	0},
					{8,		ID_REWIND,		TBSTATE_ENABLED,	0,				0,	0},
					{9,		ID_MIDIRESET,	TBSTATE_ENABLED,	0,				0,	0},
					{0,		0,				0,					TBSTYLE_SEP,	0,	0},
					{10,	ID_DETAILWND,	TBSTATE_ENABLED,	0,				0,	0},
					{0,		0,				0,					TBSTYLE_SEP,	0,	0},
					{11,	ID_HELPINDEX,	TBSTATE_ENABLED,	0,				0,	0},
				};

				SendMessage(hToolWnd, TB_ADDBUTTONS, sizeof(tbb) / sizeof(TBBUTTON), (LPARAM)tbb);
			}

			hPRollWnd = CreateWindowEx(0, "MMFToolPRollWC", "", WS_CHILD | WS_VISIBLE | WS_HSCROLL | WS_VSCROLL, 0, 0, rc.right, rc.bottom, hWnd, NULL, GetModuleHandle(NULL), NULL);
		}

		break;
	case WM_MOUSEWHEEL:
		SendMessage(hPRollWnd, msg, wParam, lParam);
		break;
	case WM_KEYDOWN:
		if((int)wParam == VK_SHIFT)
			if(!isinputting)
			{
				isinputting = TRUE;
				isinputfirst = TRUE;
				inputtingnum = 0;
				inputtingtype = 0;

				{
					LPTSTR str;

					str = halloc(256);
					lstrcpy(str, "Shift-Option?");
					SendMessage(hPRollWnd, WM_PROLL, PROLLWM_SETOPTIONSTRING, (LPARAM)str);
					InvalidateRect(hPRollWnd, NULL, FALSE);
				}
			}

		if(isinputting)
		{
			if('0' <= (int)wParam && (int)wParam <= '9')
			{
				if(isinputfirst)
				{
					isinputfirst = FALSE;
					inputtingnum = 0;
				}
				inputtingnum = inputtingnum * 10 + (int)wParam - '0';
				formatso(inputtingtype, inputtingnum);
				InvalidateRect(hPRollWnd, NULL, FALSE);
			}
			if((int)wParam == VK_OEM_MINUS)
			{
				inputtingnum = -inputtingnum;
				formatso(inputtingtype, inputtingnum);
				InvalidateRect(hPRollWnd, NULL, FALSE);
			}
			if((int)wParam == VK_BACK || (int)wParam == VK_DELETE)
			{
				inputtingnum = inputtingnum / 10;
				formatso(inputtingtype, inputtingnum);
				InvalidateRect(hPRollWnd, NULL, FALSE);
			}
			if(('A' <= (int)wParam && (int)wParam <= 'Z') || (int)wParam == VK_ESCAPE || (int)wParam == VK_OEM_2)
			{
				inputtingtype = (char)wParam;
				isinputfirst = TRUE;
				switch(inputtingtype)
				{
				case 'R':	inputtingnum = refrate;														break;
				case 'D':	inputtingnum = MainOption.DrawFunc;											break;
				case 'H':	inputtingnum = SendMessage(hPRollWnd, WM_PROLL, PROLLWM_GETROLLHEIGHT, 0);	break;
				case 'T':	inputtingnum = EmuGetTempo();												break;
				case 'K':	inputtingnum = EmuGetKeypitch();											break;
				case 'W':	inputtingnum = SendMessage(hPRollWnd, WM_PROLL, PROLLWM_GETROLLWIDTH, 0);	break;
				case 'F':	inputtingnum = MainOption.FollowPlay;										break;
				case 'S':	inputtingnum = -MainOption.FollowSpace;										break;
				case 'G':
					if(smaf)
						inputtingnum = PlayingPos;
					break;
				case 'V':	inputtingnum = EmuGetVolume();												break;
				case 'M':	inputtingnum = SendMessage(hPRollWnd, WM_PROLL, PROLLWM_GETSCROLL, 0);		break;
				case 'O':	inputtingnum = MainOption.PlayVisibleOnly;									break;
				}
				formatso(inputtingtype, inputtingnum);
				InvalidateRect(hPRollWnd, NULL, FALSE);
			}
		}else
		{
			if(!(GetAsyncKeyState(VK_SHIFT) & 0x8000) && !(GetAsyncKeyState(VK_CONTROL) & 0x8000) && !(GetAsyncKeyState(VK_MENU) & 0x8000))
			{
				switch((int)wParam)
				{
				case '0':	setvtrack(-1);	break;

				case '1':	setvtrack(0);	break;
				case '2':	setvtrack(1);	break;
				case '3':	setvtrack(2);	break;
				case '4':	setvtrack(3);	break;
				case '5':	setvtrack(4);	break;
				case '6':	setvtrack(5);	break;
				case '7':	setvtrack(6);	break;
				case '8':	setvtrack(7);	break;
				case 'Q':	setvtrack(8);	break;
				case 'W':	setvtrack(9);	break;
				case 'E':	setvtrack(10);	break;
				case 'R':	setvtrack(11);	break;
				case 'T':	setvtrack(12);	break;
				case 'Y':	setvtrack(13);	break;
				case 'U':	setvtrack(14);	break;
				case 'I':	setvtrack(15);	break;

				}
				if(MainOption.PlayVisibleOnly)
					EmuMIDISetSoloCh(SendMessage(hPRollWnd, WM_PROLL, PROLLWM_GETVISIBLETRACK, 0));
			}
		}

		switch((int)wParam)
		{
		case VK_LEFT:
			if(smaf)
			{
				UINT movval = 1000;

				if(GetAsyncKeyState(VK_CONTROL) & 0x8000)
					movval = 100;

				if((smaf->start->time - smaf->start->duration) + movval <= PlayingPos)
					seek(smaf, PlayingPos - movval, emusounding || midisounding, FALSE);
				else
					seek(smaf, smaf->start->time - smaf->start->duration, emusounding || midisounding, FALSE);

				settitle(hWnd, smaf, emusounding, midisounding);
			}
			break;
		case VK_RIGHT:
			if(smaf)
			{
				UINT movval = 1000;

				if(GetAsyncKeyState(VK_CONTROL) & 0x8000)
					movval = 100;

				seek(smaf, PlayingPos + movval, emusounding || midisounding, FALSE);

				settitle(hWnd, smaf, emusounding, midisounding);
			}
			break;
		}
		break;
	case WM_KEYUP:
		if((int)wParam == VK_SHIFT)
			if(isinputting)
			{
				isinputting = FALSE;
				switch(inputtingtype)
				{
				case 'R':
					if(0 < inputtingnum)
						refrate = inputtingnum;
					if(emusounding || midisounding)
					{
						KillTimer(hWnd, 0);
						SetTimer(hWnd, 0, refrate, NULL);
					}
					break;
				case 'D':
					if(0 <= inputtingnum && inputtingnum <= 2)
						MainOption.DrawFunc = inputtingnum;
					break;
				case 'H':
					if(0 < inputtingnum)
						SendMessage(hPRollWnd, WM_PROLL, PROLLWM_SETROLLHEIGHT, inputtingnum);
					break;
				case 'T':
					if(70 <= inputtingnum && inputtingnum <= 130)
					{
						// e|(%) between 70 to 130.
						EmuSetTempo(inputtingnum);
					}
					break;
				case 'K':
					if(-12 <= inputtingnum && inputtingnum <= 12)
					{
						EmuSetKeypitch(inputtingnum);
					}
					break;
				case 'W':
					if(0 < inputtingnum)
						SendMessage(hPRollWnd, WM_PROLL, PROLLWM_SETROLLWIDTH, inputtingnum);
					break;
				case 'F':
					if(0 <= inputtingnum && inputtingnum <= 3)
						MainOption.FollowPlay = inputtingnum;
					break;
				case 'S':
					MainOption.FollowSpace = -inputtingnum;
					break;
				case 'G':
					if(smaf && 0 <= inputtingnum)
					{
						seek(smaf, inputtingnum, emusounding || midisounding, TRUE);

						settitle(hWnd, smaf, emusounding, midisounding);
					}
					break;
				case 'V':
					if(0 <= inputtingnum && inputtingnum <= 127)
					{
						//  between 0 to 127
						EmuSetVolume(inputtingnum);
					}
					break;
				case 'M':
					if(0 <= inputtingnum)
						SendMessage(hPRollWnd, WM_PROLL, PROLLWM_SCROLLTO, inputtingnum);
					break;
				case 'O':
					if(0 <= inputtingnum && inputtingnum <= 1)
					{
						MainOption.PlayVisibleOnly = inputtingnum;
						if(MainOption.PlayVisibleOnly)
							EmuMIDISetSoloCh(SendMessage(hPRollWnd, WM_PROLL, PROLLWM_GETVISIBLETRACK, 0));
						else
							EmuMIDISetSoloCh(-1);
					}
					break;
				}
				hfree((void*)SendMessage(hPRollWnd, WM_PROLL, PROLLWM_GETOPTIONSTRING, 0));
				SendMessage(hPRollWnd, WM_PROLL, PROLLWM_SETOPTIONSTRING, 0);
				InvalidateRect(hPRollWnd, NULL, FALSE);
			}
		break;
	case WM_INITMENUPOPUP:
		{
			HMENU hm = (HMENU)wParam;
			int i;
			int max = GetMenuItemCount(hm);

			for(i = 0; i < max; i++)
			{
				MENUITEMINFO mii = {0};

				mii.cbSize = sizeof(mii);
				mii.fMask = MIIM_ID;
				GetMenuItemInfo(hm, i, TRUE, &mii);
				switch(mii.wID)
				{
				case ID_VTRACK1:
				case ID_VTRACK2:
				case ID_VTRACK3:
				case ID_VTRACK4:
				case ID_VTRACK5:
				case ID_VTRACK6:
				case ID_VTRACK7:
				case ID_VTRACK8:
				case ID_VTRACK9:
				case ID_VTRACK10:
				case ID_VTRACK11:
				case ID_VTRACK12:
				case ID_VTRACK13:
				case ID_VTRACK14:
				case ID_VTRACK15:
				case ID_VTRACK16:
					mii.fMask = MIIM_ID | MIIM_TYPE;
					mii.fType = MFT_OWNERDRAW;
					SetMenuItemInfo(hm, i, TRUE, &mii);
					break;
				}
			}
		}
		break;
	case WM_MEASUREITEM:
		{
			LPMEASUREITEMSTRUCT mis = (LPMEASUREITEMSTRUCT)lParam;

			if(mis->CtlType == ODT_MENU)
			{	// ͂ЂǂMeasureItem...
				HDC hmwdc;
				HDC hdc;
				NONCLIENTMETRICS ncm;
				HFONT hfold;
				SIZE s;
				TCHAR str[256];

				hmwdc = GetDC(hWnd);
				hdc = CreateCompatibleDC(hmwdc);

				ncm.cbSize = sizeof(ncm);
				SystemParametersInfo(SPI_GETNONCLIENTMETRICS, sizeof(ncm), &ncm, 0);

				hfold = SelectObject(hdc, CreateFontIndirect(&ncm.lfMenuFont));

				getTrackMenuItem(mis->itemID, str, NULL, NULL);
				GetTextExtentPoint32(hdc, str, lstrlen(str), &s);
				mis->itemWidth = s.cx + 4;
				mis->itemHeight = s.cy + 4;

				DeleteObject(SelectObject(hdc, hfold));
				DeleteDC(hdc);
				ReleaseDC(hWnd, hmwdc);
			}
		}
		break;
	case WM_DRAWITEM:
		{
			LPDRAWITEMSTRUCT dis = (LPDRAWITEMSTRUCT)lParam;

			if(dis->CtlType == ODT_MENU)
			{
				TCHAR str[256];
				MENUITEMINFO mii = {0};
				COLORREF bg = 0xFF000000, fg;

				getTrackMenuItem(dis->itemID, str, &fg, &bg);

				if(bg != 0xFF000000)
				{
					SIZE s;

					SaveDC(dis->hDC);
					SetBkMode(dis->hDC, TRANSPARENT);

					if(dis->itemState & ODS_SELECTED)
					{
						SetTextColor(dis->hDC, fg);
						FillRectangle(dis->hDC, dis->rcItem.left, dis->rcItem.top, dis->rcItem.right, dis->rcItem.bottom, RGB(128, 0, 128));
						FillRectangle(dis->hDC, dis->rcItem.left + 1, dis->rcItem.top + 1, dis->rcItem.right - 1, dis->rcItem.bottom - 1, bg);
					}else
						FillRectangle(dis->hDC, dis->rcItem.left, dis->rcItem.top, dis->rcItem.right, dis->rcItem.bottom, GetSysColor(COLOR_3DFACE));

					GetTextExtentPoint32(dis->hDC, str, lstrlen(str), &s);

					TextOut(dis->hDC, dis->rcItem.left + 2, dis->rcItem.top + (dis->rcItem.bottom - dis->rcItem.top - s.cy) / 2, str, lstrlen(str));

					RestoreDC(dis->hDC, -1);
				}
			}
		}
		break;
	case WM_DROPFILES:
		{
			HDROP hd = (HDROP)wParam;
			TCHAR fn[MAX_PATH];

			DragQueryFile(hd, 0, fn, sizeof(fn));
			DragFinish(hd);

			OpenSMAFCommand(hWnd, &smaf, fn);
		}
		break;
	case WM_COMMAND:
		switch(HIWORD(wParam))
		{
		case 0:	// Command
		case 1:	// Accelerator
			switch(LOWORD(wParam))
			{
			case ID_NEWSMAF:
				if(smaf)
					SendMessage(hWnd, WM_COMMAND, ID_CLOSE, 0);
				if(!(smaf = CreateSmaf(4, 4)))
					MessageBox(hWnd, "CreateSmaf failed", "Error", MB_ICONERROR | MB_OK);

				SetScrollPos(hWnd, SB_HORZ, 0, TRUE);
				SetScrollPos(hWnd, SB_VERT, 0, TRUE);

				SendMessage(hDetailWnd, WM_USER, 0, (LPARAM)smaf);
				SendMessage(hPRollWnd, WM_PROLL, PROLLWM_SETSMAF, (LPARAM)smaf);

				settitle(hWnd, smaf, emusounding, midisounding);
				break;
			case ID_OPENSMAF:
				{
					OPENFILENAME ofn = {0};
					TCHAR fname[MAX_PATH];

					ofn.lStructSize = sizeof(ofn);
					ofn.Flags = OFN_FILEMUSTEXIST;
					ofn.hInstance = GetModuleHandle(NULL);
					ofn.hwndOwner = hWnd;
					ofn.lpstrTitle = "Open SMAF";
					fname[0] = '\0';
					ofn.lpstrFile = fname;
					ofn.nMaxFile = sizeof(fname);
					ofn.lpstrFilter = "SMAF file(*.mmf)\0*.mmf\0SMAF(Motion?) file(*.mqf)\0*.mqf\0";

					if(GetOpenFileName(&ofn))
						OpenSMAFCommand(hWnd, &smaf, fname);
				}
				break;
			case ID_CLOSE:
				if(smaf)
				{
					if(emusounding)
						SendMessage(hWnd, WM_COMMAND, ID_STOP, 0);
					if(midisounding)
						SendMessage(hWnd, WM_COMMAND, ID_STOP, 0);

					// go 0ms
					SendMessage(hPRollWnd, WM_PROLL, PROLLWM_SETCURRENTPOS, 0);

					smaf = FreeSmaf(smaf);

					SendMessage(hDetailWnd, WM_USER, 0, (LPARAM)smaf);
					SendMessage(hPRollWnd, WM_PROLL, PROLLWM_SETSMAF, (LPARAM)smaf);

					settitle(hWnd, smaf, emusounding, midisounding);

					InvalidateRect(hWnd, NULL, FALSE);
				}
				break;
			case ID_COMPILESMAF:
				if(smaf)
				{
					BYTE* dt;
					DWORD ds;

					if(dt = CompileSmaf(smaf, &ds))
					{
						hfree(smaf->data);
						smaf->data = dt;
						smaf->size = ds;

						SendMessage(hPRollWnd, WM_PROLL, PROLLWM_SETHILIGHTEVENT, 0);

						ReloadSmaf(smaf);

						InvalidateRect(hDetailWnd, NULL, FALSE);
						InvalidateRect(hPRollWnd, NULL, FALSE);

						MessageBox(hWnd, "SMAF successfully compiled.\nTest with Emuplay or save SMAF.", "CompileSMAF", MB_ICONASTERISK | MB_OK);
					}else
						MessageBox(hWnd, "SMAF compile failed", "CompileSMAF Error", MB_ICONERROR | MB_OK);
				}else
					MessageBox(hWnd, "SMAF not opened", "CompileSMAF Error", MB_ICONERROR | MB_OK);
				break;
			case ID_SAVESMAF:
				if(smaf)
				{
					if(smaf->data)
					{
						OPENFILENAME ofn = {0};
						TCHAR fname[MAX_PATH];

						ofn.lStructSize = sizeof(ofn);
						ofn.Flags = OFN_FILEMUSTEXIST;
						ofn.hInstance = GetModuleHandle(NULL);
						ofn.hwndOwner = hWnd;
						ofn.lpstrTitle = "Compile and Save SMAF: Don't forget compile before save!";
						fname[0] = '\0';
						ofn.lpstrFile = fname;
						ofn.nMaxFile = sizeof(fname);
						ofn.lpstrFilter = "SMAF file(*.mmf)\0*.mmf\0";

						if(GetSaveFileName(&ofn))
						{
							HANDLE hf;

							if((hf = CreateFile(fname, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, 0, NULL)) == INVALID_HANDLE_VALUE)
								MessageBox(hWnd, "Can't open file to write", "Error", MB_ICONERROR | MB_OK);
							else
							{
								DWORD wr;

								WriteFile(hf, smaf->data, smaf->size, &wr, NULL);
								CloseHandle(hf);
							}
						}
					}else
						MessageBox(hWnd, "SMAF not compiled", "Error", MB_ICONERROR | MB_OK);
				}else
					MessageBox(hWnd, "SMAF not opened", "Error", MB_ICONERROR | MB_OK);
				break;
			case ID_EXIT:
				PostMessage(hWnd, WM_CLOSE, 0, 0);
				break;
			case ID_HELPINDEX:
				MessageBox(hWnd, "There are no help.", "sorry", MB_ICONERROR | MB_OK);
				break;
			case ID_ABOUT:
				DialogBoxParam(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_ABOUT), hWnd, AboutDlgWndProc, 0);
				break;
			case ID_PLAY:
				if(smaf && !emusounding && !midisounding)
				{
					UINT startfrom = PlayingPos;
					UINT beginpoint = 0;

					SetWindowText(hWnd, "MMF Tool <Starting play...>");

					if(smaf->start)
					{
						beginpoint = smaf->start->time - smaf->start->duration;
						if(startfrom < beginpoint)
							startfrom = beginpoint;
					}

					SendMessage(hPRollWnd, WM_PROLL, PROLLWM_SETREADONLY, TRUE);

					EmuSMAFPlay(smaf, startfrom - beginpoint);
					emusounding = TRUE;
					SetTimer(hWnd, 0, refrate, NULL);
				}
				break;
			case ID_MIDIPLAY:
				if(smaf && !midisounding && !emusounding)
				{
					UINT startfrom = PlayingPos;
					UINT beginpoint = 0;

					SetWindowText(hWnd, "MMF Tool <Starting play...>");

					if(smaf->start)
					{
						beginpoint = smaf->start->time - smaf->start->duration;
						if(startfrom < beginpoint)
							startfrom = beginpoint;
					}
					EmuMIDIPlay(smaf, startfrom - beginpoint);
					midisounding = TRUE;
					SetTimer(hWnd, 0, refrate, NULL);
					SetTimer(hWnd, 1, 10, NULL);
				}
				break;
			case ID_STOP:
				if(smaf && emusounding)
				{
					SetWindowText(hWnd, "MMF Tool <Stopping play...>");

					EmuSMAFStop();
					InitMidiMode();
					emusounding = FALSE;
					KillTimer(hWnd, 0);

					SendMessage(hPRollWnd, WM_PROLL, PROLLWM_SETREADONLY, FALSE);

					settitle(hWnd, smaf, emusounding, midisounding);

					InvalidateRect(hWnd, NULL, FALSE);
				}
				if(smaf && midisounding)
				{
					SetWindowText(hWnd, "MMF Tool <Stopping play...>");

					EmuMIDIStop();
					midisounding = FALSE;
					KillTimer(hWnd, 0);
					KillTimer(hWnd, 1);

					settitle(hWnd, smaf, emusounding, midisounding);

					InvalidateRect(hWnd, NULL, FALSE);
				}
				break;
			case ID_REWIND:
				if(smaf)
				{
					if(smaf->start)
						seek(smaf, smaf->start->time - smaf->start->duration, emusounding || midisounding, FALSE);
					else
						seek(smaf, 0, emusounding || midisounding, FALSE);

					settitle(hWnd, smaf, emusounding, midisounding);
				}
				break;
			case ID_MIDIRESET:
				InitMidiMode();

				break;
			case ID_DETAILWND:
				ShowWindow(hDetailWnd, SW_SHOW);
				SetForegroundWindow(hDetailWnd);
				break;
			case ID_VTRACKALL:	setvtrack(-1);	break;
			case ID_VTRACK1:	setvtrack(0);	break;
			case ID_VTRACK2:	setvtrack(1);	break;
			case ID_VTRACK3:	setvtrack(2);	break;
			case ID_VTRACK4:	setvtrack(3);	break;
			case ID_VTRACK5:	setvtrack(4);	break;
			case ID_VTRACK6:	setvtrack(5);	break;
			case ID_VTRACK7:	setvtrack(6);	break;
			case ID_VTRACK8:	setvtrack(7);	break;
			case ID_VTRACK9:	setvtrack(8);	break;
			case ID_VTRACK10:	setvtrack(9);	break;
			case ID_VTRACK11:	setvtrack(10);	break;
			case ID_VTRACK12:	setvtrack(11);	break;
			case ID_VTRACK13:	setvtrack(12);	break;
			case ID_VTRACK14:	setvtrack(13);	break;
			case ID_VTRACK15:	setvtrack(14);	break;
			case ID_VTRACK16:	setvtrack(15);	break;
			}
			break;
		}
		break;
	case WM_MBUTTONDOWN:
		{
			HMENU hm[9] = {0};
			POINT pt;
			int gr;
			int ret;

			hm[0] = CreatePopupMenu();

			for(gr = 0; gr < 8; gr++)
			{
				int i;

				hm[gr + 1] = CreatePopupMenu();

				for(i = 0; i < 16; i++)
				{
					char ts[32];

					wsprintf(ts, "%d: %s", gr * 16 + i, voices[gr * 16 + i].name);
					InsertMenu(hm[gr + 1], i, MF_BYPOSITION | MF_STRING | ((pch == gr * 16 + i) ? MF_CHECKED : 0), gr * 16 + i + 100, ts);
				}

				{
					char ts[32];
					wsprintf(ts, "Inst# %d - %d", gr * 16, gr * 16 + 15);
					InsertMenu(hm[0], gr, MF_BYPOSITION | MF_POPUP | ((gr * 16 <= pch && pch <= gr * 16 + 15) ? MF_CHECKED : 0), (UINT)hm[gr + 1], ts);
				}
			}

			GetCursorPos(&pt);
			ret = (int)TrackPopupMenu(hm[0], TPM_RETURNCMD, pt.x, pt.y, 0, hWnd, NULL);

			for(gr = 0; gr < 8; gr++)
				DestroyMenu(hm[gr + 1]);

			DestroyMenu(hm[0]);

			if(ret >= 100)
				pch = ret - 100;
		}
		break;
	case WM_PROLLNOTIFY:
		switch(LOWORD(wParam))
		{
		case PN_CURRENTPOSCHANGED:
			if(smaf)
			{
				UINT pos = lParam;
				if(smaf->start && pos < (smaf->start->time - smaf->start->duration))
					pos = smaf->start->time - smaf->start->duration;
				seek(smaf, pos, emusounding || midisounding, FALSE);

				settitle(hWnd, smaf, emusounding, midisounding);
			}
			break;
		case PN_CLICKED:
			if(emusounding)
				break;

			// MasterVolume
			EmuMIDISetVolume();

			{
				int vt = SendMessage(hPRollWnd, WM_PROLL, PROLLWM_GETVISIBLETRACK, 0);
				UINT tr = (vt == -1) ? 0 : vt;
				int bm = -1, bl = -1, pc = -1;

				// TODO: ʒu(lParam)ɂ鉹F(PCƂCCŕς邩)

				if(smaf && SendMessage(hPRollWnd, WM_PROLL, PROLLWM_GETVISIBLETRACK, 0) != -1)
				{
					EVENT* ev;

					for(ev = smaf->events; ev; ev = ev->next)
					{
						if((ev->status & 0x0F) == (BYTE)tr)
						{
							if((ev->status & 0xF0) == 0xB0)
							{
								if(ev->data[0] == 0x00)
									bm = ev->data[1];
								if(ev->data[0] == 0x20)
									bl = ev->data[1];
							}
							if((ev->status & 0xF0) == 0xC0)
								pc = ev->data[0];

							if(bm != -1 && bl != -1 && pc != -1)
								break;
						}
					}

					if(bm != -1 && bl != -1 && pc != -1)
						for(ev = smaf->events; ev; ev = ev->next)
						{
							if(ev->status == 0xF0)
							{
								BYTE cmd[] = {0x43, 0x79, 0x06, 0x7F, 0x01, bm, bl, pc};
								if(!memcomp(ev->data + 1, cmd, sizeof(cmd)))
								{
									DoEvent(ev, FALSE);
									break;
								}
							}
						}
				}

				if(bm == -1)
					if(GetAsyncKeyState(VK_SHIFT) & 0x8000)
						bm = 125;	// drum
					else
						bm = 124;
				if(bl == -1)
					bl = 0;
				if(pc == -1)
					pc = pch;

				// CC BankSelect
				{
					BYTE cmd[] = {0xB0 | tr, 0x00, bm};
					if(EmuSetMidiMsg(cmd, 3))
					{
						MessageBox(hWnd, "SetMidiMsg5 failed", "Error", MB_ICONERROR | MB_OK);
						break;
					}
				}
				{
					BYTE cmd[] = {0xB0 | tr, 0x20, bl};
					if(EmuSetMidiMsg(cmd, 3))
					{
						MessageBox(hWnd, "SetMidiMsg6 failed", "Error", MB_ICONERROR | MB_OK);
						break;
					}
				}
				// PC
				{
					BYTE cmd[] = {0xC0 | tr, pc};
					if(EmuSetMidiMsg(cmd, 2))
					{
						MessageBox(hWnd, "SetMidiMsg7 failed", "Error", MB_ICONERROR | MB_OK);
						break;
					}
				}
				// NoteON
				{
					BYTE cmd[] = {0x90 | tr, (BYTE)HIWORD(wParam), 0x7F};
					sndch = tr;
					if(EmuSetMidiMsg(cmd, 3))
					{
						MessageBox(hWnd, "SetMidiMsg8[sounding note] failed", "Error", MB_ICONERROR | MB_OK);
						break;
					}
				}

				sndy = HIWORD(wParam);
			}

			break;
		case PN_RELEASED:
			if(emusounding)
				break;

			if(sndy == -1)
				break;

			// NoteOFF
			{
				BYTE cmd[] = {0x90 | sndch, sndy, 0x00};
				if(EmuSetMidiMsg(cmd, sizeof(cmd)))
				{
					MessageBox(hWnd, "SetMidiMsg8[sounding] failed", "Error", MB_ICONERROR | MB_OK);
					break;
				}
			}

			break;
		}
		break;
	case WM_TIMER:
		if(emusounding)
		{
			UINT beginpoint = 0;
			if(smaf->start)
				beginpoint = smaf->start->time - smaf->start->duration;
			PlayingPos = EmuGetCurrentPos() + beginpoint;
			SendMessage(hPRollWnd, WM_PROLL, PROLLWM_SETCURRENTPOS, PlayingPos);

			settitle(hWnd, smaf, emusounding, midisounding);

			switch(EmuStatus())
			{
			case EMUSTATUS_PLAYING:
				break;
			case EMUSTATUS_READY:	// music stop.
				SendMessage(hWnd, WM_COMMAND, ID_STOP, 0);
				break;
			default:	// z͈̔͊OłB
				SendMessage(hWnd, WM_COMMAND, ID_STOP, 0);
				MessageBox(hWnd, "Status is NOT 4(Playing) or 3(Ready)\nSTOPPED.", "Error", MB_ICONERROR | MB_OK);
				break;
			}
		}

		if(midisounding)
		{
			if(wParam == 0)	// ID:0 = Redraw
			{
				SendMessage(hPRollWnd, WM_PROLL, PROLLWM_SETCURRENTPOS, PlayingPos);

				settitle(hWnd, smaf, emusounding, midisounding);
			}
			if(wParam == 1)	// ID:1 = MIDIProc
			{
				EmuMIDIProc();

				PlayingPos = EmuGetCurrentPos();

				switch(EmuStatus())
				{
				case EMUSTATUS_PLAYING:
					break;
				case EMUSTATUS_READY:	// music stop.
					SendMessage(hWnd, WM_COMMAND, ID_STOP, 0);
					break;
				default:	// z͈̔͊OłB
					SendMessage(hWnd, WM_COMMAND, ID_STOP, 0);
					MessageBox(hWnd, "Status is NOT 4(Playing) or 3(Ready)\nSTOPPED.", "Error", MB_ICONERROR | MB_OK);
					break;
				}
			}
		}

		if((emusounding || midisounding) && wParam == 0)
		{
			static DWORD lastrefresh = 0;	// KH

			RECT rc;

			GetClientRect(hWnd, &rc);

			// FollowMove
			if(MainOption.FollowPlay == 1 || (MainOption.FollowPlay == 2 && GetAsyncKeyState(VK_SHIFT) & 0x8000))
			{
				SendMessage(hPRollWnd, WM_PROLL, MAKEWPARAM(PROLLWM_SCROLLTO, MainOption.FollowSpace), PlayingPos);
			}
			if(MainOption.FollowPlay == 3 && ((PlayingPos < (UINT)SendMessage(hPRollWnd, WM_PROLL, PROLLWM_GETSCROLL, 0)) || (GetScrollPos(hPRollWnd, SB_HORZ) + rc.right + MainOption.FollowSpace) * (UINT)SendMessage(hPRollWnd, WM_PROLL, PROLLWM_GETROLLWIDTH, 0) < PlayingPos))
			{
				SendMessage(hPRollWnd, WM_PROLL, MAKEWPARAM(PROLLWM_SCROLLTO, (short)MainOption.FollowSpace), PlayingPos);
			}
			//InvalidateRect(hWnd, NULL, FALSE);

			// refresh DetailWnd
			if(lastrefresh + 100 < GetTickCount())
			{
				lastrefresh = GetTickCount();
				InvalidateRect(hDetailWnd, NULL, FALSE);
			}
		}

		break;
	case WM_SIZE:
		SendMessage(hToolWnd, TB_AUTOSIZE, 0, 0);
		{
			RECT rc = {0};
			GetClientRect(hToolWnd, &rc);
			SetWindowPos(hPRollWnd, NULL, 0, rc.bottom, LOWORD(lParam), HIWORD(lParam) - rc.bottom, SWP_NOZORDER);
		}
		break;
	case WM_CLOSE:
		if(smaf)
			SendMessage(hWnd, WM_COMMAND, ID_CLOSE, 0);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		ImageList_Destroy((HIMAGELIST)SendMessage(hToolWnd, TB_GETIMAGELIST, 0, 0));
		DestroyWindow(hDetailWnd);
		if(voices)
			hfree(voices);
		break;
	}

	return DefWindowProc(hWnd, msg, wParam, lParam);
}

BOOL initWnd(void)
{
	WNDCLASSEX wc = {0};
	
	wc.cbSize = sizeof(wc);
	wc.hbrBackground = (HBRUSH)(COLOR_3DFACE + 1);
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hInstance = GetModuleHandle(NULL);
	wc.hIcon = LoadIcon(wc.hInstance, MAKEINTRESOURCE(IDI_MAIN));
	wc.lpfnWndProc = MainWndProc;
	wc.lpszClassName = "MMFToolWC";
	wc.lpszMenuName = MAKEINTRESOURCE(IDR_MAIN);

	if(!RegisterClassEx(&wc))
		return FALSE;

	// I don't like WS_OVERLAPPED.
	if(!(hMainWnd = CreateWindowEx(WS_EX_ACCEPTFILES, wc.lpszClassName, "MMF Tool", WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX | WS_SIZEBOX | WS_MAXIMIZEBOX | WS_VISIBLE, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, wc.hInstance, NULL)))
		return FALSE;

	//wc.cbSize = sizeof(wc);
	//wc.hbrBackground = (HBRUSH)(COLOR_3DFACE + 1);
	//wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	//wc.hInstance = GetModuleHandle(NULL);
	//wc.hIcon = LoadIcon(wc.hInstance, MAKEINTRESOURCE(IDI_MAIN));
	wc.lpfnWndProc = DetailWndProc;
	wc.lpszClassName = "MMFToolDetailWC";
	wc.lpszMenuName = NULL;

	if(!RegisterClassEx(&wc))
		return FALSE;

	if(!(hDetailWnd = CreateWindowEx(WS_EX_CLIENTEDGE, wc.lpszClassName, "MMF Tool - DetailView", WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX | WS_SIZEBOX | WS_MAXIMIZEBOX | WS_HSCROLL | WS_VSCROLL, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, wc.hInstance, NULL)))
		return FALSE;

	return TRUE;
}

void ReadConfig(void)
{
	MainOption.DrawFunc = 2;
	MainOption.FollowPlay = 0;
	MainOption.FollowSpace = -100;
	MainOption.PlayVisibleOnly = FALSE;

	MainOption.TrackColors[0]	= RGB(192, 192, 192);
	MainOption.TrackColors[1]	= RGB(255, 128, 128);
	MainOption.TrackColors[2]	= RGB(128, 255, 128);
	MainOption.TrackColors[3]	= RGB(128, 128, 255);
	MainOption.TrackColors[4]	= RGB(255, 255, 128);
	MainOption.TrackColors[5]	= RGB(128, 255, 255);
	MainOption.TrackColors[6]	= RGB(255, 128, 255);
	MainOption.TrackColors[7]	= RGB(255, 255, 255);
	MainOption.TrackColors[8]	= RGB(  0,   0,   0);
	MainOption.TrackColors[9]	= RGB(128,   0,   0);
	MainOption.TrackColors[10]	= RGB(  0, 128,   0);
	MainOption.TrackColors[11]	= RGB(  0,   0, 128);
	MainOption.TrackColors[12]	= RGB(128, 128,   0);
	MainOption.TrackColors[13]	= RGB(  0, 128, 128);
	MainOption.TrackColors[14]	= RGB(128,   0, 128);
	MainOption.TrackColors[15]	= RGB(128, 128, 128);

	MainOption.PRollOption.RollHeight = 3;
	MainOption.PRollOption.RollWidth = 25;
	MainOption.PRollOption.NiagaraTouch = TRUE;

	return;
}

void WinMainCRTStartup(void)
{
	ReadConfig();

	if(!EmuInitialize())
		ExitProcess(0);

	if(!PRollInitialize())
		ExitProcess(0);

	InitCommonControls();

	if(!initWnd())
		ExitProcess(0);

	{
		MSG msg;
		HACCEL at;

		at = LoadAccelerators(GetModuleHandle(NULL), MAKEINTRESOURCE(IDR_MAIN));

		while(GetMessage(&msg, NULL, 0, 0))
		{
			if(!TranslateAccelerator(msg.hwnd, at, &msg))
				TranslateMessage(&msg);
			DispatchMessage(&msg);
		}

		EmuUninitialize();

		ExitProcess(msg.wParam);
	}
}
